# -*- coding: utf-8 -*-
"""
Created on Fri Aug 14 17:09:38 2015

@author: Ricco
"""

import numpy as np
import scipy.stats as stat

d = np.array([0.553,0.57,0.576,0.601,0.606,0.606,0.609,0.611,0.615,0.628,0.654,0.662,0.668,0.67,0.672,0.69,0.693,0.749])

#objet statistique descriptives
stat_des = stat.describe(d)
print(stat_des)

#stat_des est de type "namedtuple" du module collections
#différentes manière d'accéder aux champs

#par indice
print(stat_des[0])

#par nom
print(stat_des.nobs)

#possiblité d'éclater les résultats
n,mm,m,v,sk,kt = stat.describe(d)
print(n,m)

#médiane de NumPy
print(np.median(d))

#fonction de répartition empirique
print(stat.percentileofscore(d,0.6215))

#graphique - à voir plus en détail dans un autre cours
import matplotlib as mp

#histogramme
mp.pyplot.hist(d,bins=5)

#quantiles et valeurs fonc. répartition

#loi normale centrée et réduite
print(stat.norm.ppf(0.95,loc=0,scale=1))
print(stat.norm.cdf(1.96,loc=0,scale=1))

#loi de Student - ddl = 30
print(stat.t.ppf(0.95,df=30))
print(stat.t.cdf(1.96,df=30))

#loi du khi-2 - ddl = 10
print(stat.chi.ppf(0.95,df=10))
print(stat.chi.cdf(4.84,df=10))

#loi de Fisher, ddl numérateur = 1, ddl dénominateur = 30
print(stat.f.ppf(0.95,dfn=1,dfd=30))
print(stat.f.cdf(3.48,dfn=1,dfd=30))

#test de normalité d'Agostino
ag = stat.normaltest(d)
print(ag)

#test de Normalité Shapiro-Wilks
sp = stat.shapiro(d)
print(sp)

#test d'adéquation d'Anderson-Darling
ad = stat.anderson(d,dist="norm")
print(ad)

#test de conformité de la moyenne
print(stat.ttest_1samp(d,popmean=0.618))

#si l'on détaille les calculs
#moyenne
m = np.mean(d)
#écart-type (n-1)
sigma = np.std(d,ddof=1)
#stat. de test t
import math
t = (m - 0.618)/(sigma/math.sqrt(d.size))
print(t)

#p-value
p = 2.0 * (1.0 - stat.t.cdf(math.fabs(t),d.size-1))
print(p)

#génération de valeurs aléatoires - loi normale
alea1 = stat.norm.rvs(loc=0,scale=1,size=30)
print(stat.skew(alea1,bias=False))
print(stat.kurtosis(alea1,fisher=True,bias=False))
print(stat.normaltest(alea1))

#génération - loi exponentielle
alea2 = stat.expon.rvs(size=30)
print(stat.skew(alea2,bias=False))
print(stat.kurtosis(alea2,fisher=True,bias=False))
print(stat.normaltest(alea2))

#Numpy propose aussi un générateur
alea3 = np.random.normal(loc=0,scale=1,size=30)
print(stat.skew(alea1,bias=False))
print(stat.kurtosis(alea1,fisher=True,bias=False))
print(stat.normaltest(alea3))

#éhantillonnage de m obs. parmi n
d1 = np.random.choice(d,size=5,replace=False)
print(d1)

d2 = np.random.choice(d,size=5,replace=True)
print(d2)
